//makeProfileTimer

{   
    const makeProfileTimer = () => {
        const startOfTime = performance.now()
        function timer() {
            return performance.now() - startOfTime
        }
        return timer
    }
    
    var timer = makeProfileTimer() 
    alert('Замеряем время работы этого alert');  //некий код, время выполнения которого мы хотим измерить с высокой точностью
    alert(timer()); 
                //alert должен вывести время в микросекундах от выполнения makeProfileTimer до момента вызова timer(), 
                // т. е. измерить время выполнения alert
}


//makeSaver

{
    var saver = makeSaver(Math.random) //создает функцию-хранилище результата переданной в качестве параметра функции (Math.random 
    // в примере). На этом этапе Math.random НЕ вызывается

    function makeSaver (func){
        let result 
        return function() {
            return result ? result : result = func()
                }
    }

    var value1 = saver()              //saver вызывает переданную в makeSaver функцию, запоминает результат и возвращает его
    var value2 = saver()              //saver в дальнейшем просто хранит результат функции, и более НЕ вызывает переданную 
        //в makeSaver функцию;
    value1 === value2                 // всегда true

    var saver2 = makeSaver(() => console.log('saved function called') || [null, undefined, false, '', 0, Math.random()][Math.ceil(Math.random()*6)])
    var value3 = saver2()
    var value4 = saver2()

    value3 === value4 // тоже должно быть true



    let namePrompt = prompt.bind(window, 'Как тебя зовут?')
    let nameSaver = makeSaver(namePrompt)
    alert(`Привет! Prompt еще не было!`)
    alert(`Привет ${nameSaver()}. Только что запустился prompt, первый и последний раз`)
    alert(`Слушай, ${nameSaver()}, го пить пиво. Ведь prompt был только один раз`)
}

//myBind
{
   function myBind(func,zis,deflt){
    function myVariant(...args) {
        let [...newArray] = deflt
        let i = 0
        let j = 0
        for (let element of deflt){
            if(element === undefined){
                newArray[i] = args[j]
                j++
            }
            i++
        }
      
        return func.apply(zis,newArray)
    }
    return myVariant
   }

    var pow5 = myBind(Math.pow, Math, [, 5]) // первый параметр - функция для биндинга значений по умолчанию, 
                                                  // второй - this для этой функции, третий - массив, в котором undefined означает
                                                  // параметры, которые должны передаваться при вызове,
                                                  // а другие значения являются значениями по умолчанию:
    var cube = myBind(Math.pow, Math, [, 3]) // cube возводит число в куб

    console.log(pow5(2)) // => 32, вызывает Math.pow(2,5), соотнесите с [undefined, 5]
    console.log(cube(3)) // => 27


    var chessMin = myBind(Math.min, Math, [, 4, , 5,, 8,, 9])
    console.log(chessMin(-1,-5,3,15)) // вызывает Math.min(-1, 4, -5, 5, 3, 8, 15, 9), результат -5



    var zeroPrompt = myBind(prompt, window, [undefined, "0"]) // аналогично, только теперь задается "0" как текст по умолчанию в prompt, 
                                                              // а текст приглашения пользователя задается при вызове zeroPrompt
    var someNumber = zeroPrompt("Введите число")              // вызывает prompt("Введите число","0")

    const bindedJoiner = myBind((...params) => params.join(''), null, [, 'b', , , 'e', 'f'])//('a','c','d') === 'abcdef'
    console.log(bindedJoiner('a','c','d') === 'abcdef')
    console.log(bindedJoiner('1','2','3') === '1b23ef')
}


//CheckResult
{
    function checkResult(original, validator){
        function wrapper(...params){
            let result = null
            do {
                result = original.apply(this,params)
            } while(validator.call(this,result) === false)
            return  console.log(result)
        }
        return wrapper
    }
    
    
    //numberPrompt - это функция, которая будет запускать prompt до тех пор, пока пользователь не введет число
    const numberPrompt = checkResult(prompt, x => !isNaN(+x)) 
    let   number       = +numberPrompt("Введите число", "0")  //параметры передаются насквозь в оригинал. Не забудьте передать this, используя call или apply
    
    //gamePrompt - это функция, которая будет запускать prompt до тех пор, пока пользователь не введет одно из слов 'камень', 'ножницы', 'бумага'
    const gamePrompt   = checkResult(prompt, x => ['камень', 'ножницы', 'бумага'].includes(x.toLowerCase())) 
    const turn         = gamePrompt("Введите что то из списка: 'камень', 'ножницы', 'бумага'")

    const randomHigh = checkResult(Math.random,x => x>0.5 && x<1 )
    const result = randomHigh()

    const alwaysSayYes = checkResult(confirm,x=> x === true )
    const choise = alwaysSayYes("Choose!!!")


}
