import { useRef , useEffect, useState} from "react";
import { baseURL } from "../../../Redux/api";
import { ActionPlayPause,ActionSetDuration,ActionSetTrack,ActionSetCurrentTime, ActionNextTrack } from "../../../Redux/thunk";
import { useDispatch } from "react-redux";
import { playPause,setTrack, playerSlice, setDuration } from "../../../Redux/toolkitSilce";
import { useSelector } from "react-redux";

import { IconButton } from "@mui/material";
import { PauseRounded,PlayArrowRounded  } from "@mui/icons-material";

const Music = ({player,track,playlistIndex,active}) => {

    const dispatch = useDispatch()

    // if(!track.url){
    //     return (<></>)
    // } 



    const  handlePlayPause =  (status)  => {
            dispatch(ActionSetTrack({track,playlistIndex}));
            dispatch(ActionPlayPause(status))
        
    }
 

    // function Play()  {

    //     dispatch(setTrack({track,playlistIndex}));
    //     dispatch(ActionPlayPause(true))
    // }

    // function Pause()  {
    //     dispatch(ActionPlayPause(false))
    // }

    return (     
        <> 
            <IconButton aria-label={player.isPlaying ? 'pause' : 'play'} onClick={() => {
                if(active && player.isPlaying ){ 
                    handlePlayPause(false)
                    
                }
                else {
                    handlePlayPause(true) } }}>
                { active && player.isPlaying ? <PauseRounded/> : <PlayArrowRounded/>  }
            </IconButton>

            {/* <audio ref={audioRef} src={`${baseURL + player?.track?.url}`}></audio> */}
            {/* <audio ref={audioRef} src ={`${baseURL} + ${data}`} autoPlay = {true}></audio>     */}
        </>  
        
    );
 


}

export default Music