import { useSelector } from "react-redux"
import { useGetUserQuery } from "../Redux/api"
import { Avatar, Box, Grid, Typography } from "@mui/material"


const UserPage = () => {
    const user = useSelector( state => state.auth.user ) 
    const _id = user ? user.sub.id : null
    const {data : payload=null} = useGetUserQuery(_id)
    const userInfo = payload?.UserFindOne
    console.log(userInfo)
    return (
        <>
            <Grid direction="column">
                <Box sx={{
                    display: 'flex',
                    flexDirection: 'column'
                }} >
                    <Avatar src={userInfo?.avatar?.src ? userInfo?.avatar?.src : null  }></Avatar>
                    <Typography>{userInfo?.nick ? userInfo?.nick : "Nick" }</Typography>
                    <Typography>{userInfo?.login}</Typography>
                    
                    
                </Box>
                <Box></Box>
            </Grid>
            
        </>
    )
} 
export default UserPage;