//HTML tree
/*
{
    const table = {
        tagName: 'table',
        attrs: {
            border: "1",
        },
        children: [
            {
                tagName: 'tr',
                children: [
                    {
                        tagName: "td",
                        children: ["1x1"],
                    },
                    {
                        tagName: "td",
                        children: ["1x2"],
                    },
                ]
            },
            {
                tagName: 'tr',
                children: [
                    {
                        tagName: "td",
                        children: ["2x1"],
                    },
                    {
                        tagName: "td",
                        children: ["2x2"],
                    },
                ]
            }
        ]
    }
    

    function htmlTree(obj){
        let string = ""
        let tag = obj.tagName
        if(tag){
            string = `<${tag}`
            let attrb = obj.attrs
            if(attrb){
                for(nameAttrb in attrb){
                    string += ` style ${nameAttrb} = ${obj.attrs[nameAttrb]}`
                }
            }
                string += '>'
                for(child of obj.children){
                  string += htmlTree(child)
                }
                string+=`</${tag}>`
            

        }
        else { 
            string = obj
        }
        return string

    }


    document.write(htmlTree(table)) //вернет <table border='1' ..
    console.log(htmlTree(table))
}

//DOM tree

{
    
       

    function domTree (parent,obj) {
        if(obj.tagName){
            let tag = document.createElement(obj.tagName)
            if(obj.attrs){
                for(nameAttrb in obj.attrs){
                tag[nameAttrb] = obj.attrs[nameAttrb]
                }
            }
            parent.append(tag)
            for(child of obj.children){
                
                domTree(tag, child)
            }
        }
        else {
            parent.append(obj)
        }
        
    }
    

    const table = {
        tagName: 'table',
        attrs: {
            border: "1",
        },
        children: [
            {
                tagName: 'tr',
                children: [
                    {
                        tagName: "td",
                        children: ["1x1"],
                    },
                    {
                        tagName: "td",
                        children: ["1x2"],
                    },
                ]
            },
            {
                tagName: 'tr',
                children: [
                    {
                        tagName: "td",
                        children: ["2x1"],
                    },
                    {
                        tagName: "td",
                        children: ["2x2"],
                    },
                ]
            }
        ]
    }

    domTree(document.body, table)
}


//Deep Copy

{
    const table = {
        tagName: 'table',
        attrs: {
            border: "1",
        },
        children: [
            {
                tagName: 'tr',
                children: [
                    {
                        tagName: "td",
                        children: ["1x1"],
                    },
                    {
                        tagName: "td",
                        children: ["1x2"],
                    },
                ]
            },
            {
                tagName: 'tr',
                children: [
                    {
                        tagName: "td",
                        children: ["2x1"],
                    },
                    {
                        tagName: "td",
                        children: ["2x2"],
                    },
                ]
            }
        ]
    }

    

    function deepCopy (obj) {
        let copy
        if (Array.isArray(obj)) {
            copy =[]
        }
        else {
            copy = {}
        }
        if(obj){
            Object.keys(obj).forEach(x=>{
                if(typeof obj[x] === Object){
                    copy[x] = deepCopy(obj[x])
                }
                else copy[x] = obj[x]
            })
        }
    return copy
    }
    const arr  = [1,"string", null, undefined, {a: 15, b: 10, c: [1,2,3,4],d: undefined, e: true }, true, false]
    const arr2 = deepCopy(arr) //arr2 и все его вложенные массивы и объекты - другие объекты, которые можно менять без риска поменять что-то в arr
    const table2 = deepCopy(table) //аналогично
    console.log(arr2)
    console.log(table2)
}
*/
//My Stringify
{   
    function  stringify (obj) {
     let result = ``

     if(typeof(obj) === "number" || typeof(obj) === "boolean" || obj === null){
        return result += obj
     }
     

     if(typeof(obj) === "string"){
        return result += `"${obj}"` 
     }


      if(Array.isArray(obj)){
        result += "["
        if(obj.length > 0){
            for(value of obj){
                if(value === undefined){
                    result += `${stringify(null)}`
                }
                result += `${stringify(value)},`
            }
            result = result.slice(0, result.length - 1)
        }
        result += "]"
        return result
       
     }

        if(typeof(obj) === "object"){
            result += '{'
            
            
            if(Object.keys(obj).length > 0){
                for(key in obj){
                    if(obj[key] === undefined){
                        continue
                    }
                    result += `"${key}":`
                    result += `${stringify(obj[key])},`    
                }
                result = result.slice(0, result.length - 1)
            }
            result += '}'
        }
    
        return result
    }
    const arr  = [1,"string", null, undefined, {a: 15, b: 10, c: [1,2,3,4],d: undefined, e: true }, true, false]
    const jsonString = stringify(arr) //напишите функцию stringify без использования JSON.stringify
    console.log(jsonString)
    console.log(JSON.parse(jsonString)) //не должно поломаться и должно вернуть структуру, во всем схожую с оригинальным arr или table
    
}